<template>
  <article
    class="card-product-default py-2 px-1 px-md-3 bg-white position-relative animate__animated animate__fadeIn animate__slow shadow-card"
  >
    <span
      class="agotado d-inline-block bg-danger text-white text-uppercase px-2"
      v-if="product.stok_real == 0 || product.estado == 'Desactivado'"
      >Agotado</span
    >

    <nuxt-link
      :to="{ name: 'productos-slug', params: { slug: product.slug } }"
      class="card-image d-inline-block"
    >
      <img
        :src="product.foto_real.url"
        :alt="product.name"
        v-if="product.foto_real"
      />
    </nuxt-link>

    <section class="card-content pt-2">
      <nuxt-link
        :to="{ name: 'productos-slug', params: { slug: product.slug } }"
        class="title text-decoration-none d-lg-none"
        >{{ product.nombre | nameMobile }}</nuxt-link
      >
      <nuxt-link
        :to="{ name: 'productos-slug', params: { slug: product.slug } }"
        class="title text-decoration-none d-none d-lg-block"
        >{{ product.nombre | nameDesktop }}</nuxt-link
      >
    </section>

    <section class="price mt-3 mt-md-4">
      <div class="with-offer" v-if="product.precio_descuento">
        <h3 class="real my-0">{{ price(product.precio_real) }}</h3>
        <h3 class="offer my-0">{{ price(product.precio_descuento) }}</h3>
      </div>
      <div v-else>
        <h3 class="offer my-0">{{ price(product.precio_real) }}</h3>
      </div>
    </section>

    <AddToCart :product="product" />
  </article>
</template>

<script>
import { priceFormat } from "@/utils/price-format.js";

import AddToCart from "@/components/products/cards/AddToCart";

export default {
  name: "DefaultCard",
  components: {
    AddToCart,
  },
  props: {
    product: Object,
  },
  methods: {
    price(val) {
      return priceFormat(val);
    },
  },
  filters: {
    nameMobile: function (value) {
      if (!value) return;

      if (value.length >= 90) {
        return `${value.substring(0, 90)}...`;
      } else {
        return value;
      }
    },
    nameDesktop: function (value) {
      if (!value) return;

      if (value.length >= 100) {
        return `${value.substring(0, 100)}...`;
      } else {
        return value;
      }
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~/assets/scss/variables";

.card-product-default {
  border: 1px solid $light;

  &:hover {
    .card-image img {
      transform: scale(1.05);
    }
  }

  @media (min-width: 768px) {
    min-height: 350px;
  }

  .agotado {
    font-size: 0.9em;
    position: absolute;
    top: 0.5rem;
    left: 1rem;
    z-index: 20;
  }

  .card-image {
    @media (min-width: 768px) {
      height: 180px;
    }

    img {
      width: 100%;
      height: 100%;
      transition: transform 0.5s;
    }
  }

  .card-content {
    max-height: 60px;
  }

  .title {
    max-height: 50px;
    font-size: 0.75em;
    font-weight: 500;
    color: rgba($dark, 0.9);
    line-height: 0.8rem;
    display: inline-block;

    &:hover {
      color: $dark;
    }

    @media (min-width: 768px) {
      font-size: 0.85em;
      line-height: 1rem;
    }
  }

  .price {
    height: 40px;

    .with-offer {
      .real {
        font-size: 0.8em;
        color: rgba($dark, 0.8);
        text-decoration: line-through;
      }
    }

    h3 {
      font-size: 1.1em;
      font-weight: 700;
      margin: 0;
    }

    .offer {
      color: $primary;
    }
  }
}
</style>
